unit Anima;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,EXtCtrls,MMSystem;
  {$R Anima.res}
type
  TSpeed = 1..400;
  TAnima = class(TGraphicControl)
   private
    { Private declarations }
    FPlay:boolean;
    FSpeed:TSpeed;
    Timer:TTimer;
    FImages:TImageList;
    FCop: string;
    function GetCop: string;
    procedure SetCop(const Value: string);
    procedure SetImages(Value: TImageList);
    procedure CmVisibleChanged(var Message: TWmNoParams); message CM_VISIBLECHANGED;
    procedure CmColorChanged(var Message: TWMNoParams); message CM_PARENTCOLORCHANGED;
  protected
    { Protected declarations }
    Procedure Animate;
    Procedure RunAni;
    procedure SetPlay(APlay:boolean);
    procedure SetSpeed(value:TSpeed);
    procedure OnTimer(Sedner:Tobject);virtual;

  public

    { Public declarations }
    constructor Create(Aowner:Tcomponent);override;
    procedure paint;override;
     procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  published
    { Published declarations }
    property Play:boolean
    read FPlay write SetPlay default False;
    property Speed:Tspeed
    read  FSpeed write SetSpeed default 200;
    property Copyright: string read GetCop write SetCop;
    property Images: TImageList read FImages write SetImages;
    property ShowHint;
    property Align;
    property Visible;
    property Color;
    property Parentcolor;
    property Enabled;
    property OnClick;


  end;

procedure Register;

implementation
var x:integer;


procedure Register;
begin
  RegisterComponents('PDJ', [TAnima]);
end;

constructor TAnima.Create(AOwner:TComponent);

begin

inherited;
height:=40;
width:=40;
FPlay:=false;
FSpeed:=200;
Timer:=TTimer.Create(Self);
Timer.Interval:= FSpeed;
Timer.OnTimer:=OnTimer;
FCop:='Copyright  2001 by Peric';
 end;

procedure TAnima.CmVisibleChanged(var Message: TWmNoParams);
begin
  inherited;
  Repaint;
end;

procedure TAnima.CmColorChanged(var Message: TWMNoParams);
begin
  inherited;
  Repaint;
end;

 procedure TAnima.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = FImages) then FImages := nil;
  repaint;
end;

 procedure TAnima.Paint;
var Th,Lh:integer; R:Trect;
begin
 if FImages <> nil then begin
 R:=clientRect;
Th:=(height-FImages.Height)div 2;
Lh:=(width-FImages.width)div 2;

canvas.brush.color:=color;
canvas.Fillrect(r);
FImages.Draw(Canvas, Lh, Th, 0);
end
else
begin
R:=clientRect;
canvas.brush.color:=color;
canvas.Fillrect(r);
end;
 end;


 procedure TAnima.SetImages(Value: TimageList);

begin
  FImages := Value;
  if Value <> nil then
  begin
    Value.FreeNotification(Self);
   repaint;

end;
end;



 function TAnima.GetCop: string;
begin
  Result:=FCop;
end;

procedure TAnima.SetCop(const Value: string);
begin
  FCop:=FCop;
end;

 procedure TAnima.SetPlay(APlay:boolean);
 begin
 FPlay:=APlay;
 if csDesigning in ComponentState then
 Exit;
 Timer.enabled:=FPlay;
 end;

 procedure TAnima.SetSpeed(value:TSpeed);
 begin
  if value <> FSpeed then
  begin
    FSpeed := value;
   Timer.interval:=FSpeed;
  end;
end;


 procedure TAnima.OnTimer(Sedner:Tobject);

 begin
 if csDesigning in ComponentState then begin
 Timer.Enabled:=False;
 Exit;
 end;
 RunAni;
 end;

Procedure TAnima.Animate;
var Th,Lh:integer;
begin
if not Assigned(FImages) then exit;
Th:=(height-FImages.Height)div 2;
Lh:=(width-FImages.width)div 2;
FImages.Draw(Canvas, Lh, Th, x);
end;

Procedure TAnima.RunAni;
var r:TRect;
begin
if not FPlay then exit;
if not Assigned(FImages) then exit;
if not visible then exit;
R:=clientRect;
canvas.brush.color:=color;
canvas.Fillrect(r);
Animate;
if (x < FImages.Count-1) then x := x + 1
else x := 0;
end;
end.
